%{
  #include <stdio.h>
  #include <stdlib.h>
  #include "global.h"
  #include <string.h>
  #include "statements/printstmt.h"
  int yylex(void);
  int yyerror(const char *s);
%}

%union {
   char * string;
   int    number;
   float  fNumber;
   void * pVoid;
};

%token DIR HELP PRINT QUIT CLEAR CLS IDENTIFIER
%token ARGUMENT NUMBER STRING EXIT OPENBRACKET CLOSEBRACKET COMMA

%type <string>  STRING
%type <string>  ARGUMENT
%type <string>  IDENTIFIER
%type <fNumber> NUMBER

%%

program :  commands 
         | commands program;

commands:  
           printstmt 
         | dirstmt
         | helpstmt
 		   | quitstmt
		   | clsstmt
		   | clearstmt
         ;

printstmt:
         PRINT STRING { 
		                    printStatement($2);    
						        if(strlen(prompt) > 0) printf("\n");
                      }
         ;

dirstmt:
           DIR ARGUMENT {  
		                     if(strlen(prompt) > 0) {
		                        char *dest;
		                        char *src;
						            strcpy(dest, "dir ");
						            strcpy(src, $2);
						            strcat(dest, src);
		                        system(dest); 
						         }
					         }
		   | DIR { if(strlen(prompt) > 0) system("dir *.*"); }
         ;

helpstmt:
         HELP {
		           printf("\n");
                 printf("cls\t\t\t\tclear screen (windows)\n");
                 printf("clear\t\t\t\tclear screen (linux)\n");
                 printf("delete\t<\"file name\">\t\tdelete file in argument (windows)\n");
                 printf("dir\t<arguments>\t\tlist files in directory (windows)\n");
                 printf("EndPage\t<\"file name\">\t\tclose file HTML converted\n");
                 printf("Ls\t<arguments>\t\tlist files in directory (linux)\n");
                 printf("Page\t<\"file\", \"Title\">\tcreate file HTML to convert\n");
                 printf("Print\t<string literal>\tprint to stdout/file string literal in argument\n");
                 printf("quit | Exit\t\t\tExit this program\n");
                 printf("rm\t<\"file name\">\t\tdelete file in argument (linux)\n");
		           printf("\n");
              }
         ;

quitstmt:
         QUIT { exit(0); }
		 | EXIT { exit(0); }
         ;
		
clsstmt:
         CLS { 
		          if(strlen(prompt) > 0) {
			          system("cls"); 
	                printf("%s", consoleMex);
			       }	  
		       }
         ;

clearstmt:
         CLEAR { 
		            if(strlen(prompt) > 0) {
				         system("clear"); 
	                  printf("%s", consoleMex);
				      } 
			      }
         ;

%%
